# xDevs.com Python 10V test for 3458A
# http://xdevs.com/guide/ni_gpib_rpi/
import os.path
import sys
import Gpib
import time
import ftplib
import numbers
import signal
from Adafruit_BME280 import *

root_dir = '/repo/3458/'
fileName = root_dir + '4142b_xtvcap1_final2.csv'
cnt = 0
tread = 20
reflevel = 0.00000001
exttemp = 25.0
rh = 50.0
pascals = 100000.00
hectopascals = 1000.00

class Timeout():
  """Timeout class using ALARM signal"""
  class Timeout(Exception): pass

  def __init__(self, sec):
    self.sec = sec

  def __enter__(self):
    signal.signal(signal.SIGALRM, self.raise_timeout)
    signal.alarm(self.sec)

  def __exit__(self, *args):
    signal.alarm(0) # disable alarm

  def raise_timeout(self, *args):
    raise Timeout.Timeout()

# Read Temperature, Humidity, and Barometric Pressure from BME280
def get_THP():
    global exttemp
    global rh
    global pascals
    global hectopascals
    exttemp = sensor.read_temperature()
    rh = sensor.read_humidity()
    pascals = sensor.read_pressure()
    hectopascals = pascals / 100

def create_local_file(fileName):
    if (os.path.isfile(fileName) == False):
        with open(fileName, 'a') as o:
            o.write("date;smu_curr;smu_volt;rcalc;ext_temp;rh;pressure;\r\n")
            print ("file %s does not exist\r\n" % fileName) 
    else: 
        print ("file %s exists\r\n" % fileName)

#Setup temp/humidity/pressure sensor BME280
# OSAMPLE = oversampling mode
sensor = BME280(mode=BME280_OSAMPLE_8)
get_THP() # Read Temp, RH, Pressure from sensor

create_local_file(fileName)


inst = Gpib.Gpib(0,14) # 4142B GPIB Address = 27
inst.write("ERR?\n")
str = inst.read(400)
print str

#inst.write("*RST\n")
inst.write("*IDN?\n")
str = inst.read(40)
print str
inst.write("UNT? 1\n")
str = inst.read(140)
print str
inst.write("LOP?\n")
str = inst.read(140)
print str
#slp = 10
#inst.write("*TST?\n")
inst.write("ERR?\n")
str = inst.read(400)
print str
slp = 1

inst.write("CN 1\n")
inst.write("FMT 1,0\n")
inst.write("MM 1,1\n")
inst.write("RV 1,12\n")

print ("Reading..")
inst.write("DV 1,12,10.0,30E-9\n") #Output 10V, 12 - 10V range, 10uA current 

while cnt <= 1000000:
    cnt+= 1
    with open(fileName, 'a') as o1:# Open file handles for both files
	inst.write("LOP?\n")
	str = inst.read(140)
	#print str

        time.sleep(slp)
	volt = 10.0016

	inst.write("ERR?\n")
	str = inst.read(400)
	#print str,

	inst.write("PA 2\n")
	inst.write("XE\n")
        time.sleep(slp)
	inst.write("LOP?\n")
	str = inst.read(140)
	#print str
	inst.write("XE\n")
        time.sleep(slp)
        stri = inst.read()
#	print stri
        currs = stri.split("\r\n")
	try:
	    curv = currs[0].split("NAI")
            cur = float(curv[1])
	except:
	    curv = currs[0].split("CAI")
            cur = float(curv[1])
#	print curv
        cur = abs(float(curv[1]))

	#inst.write("TI 1,0\n") # Meas I 
        #ti = inst.read()
	#print ti

        rval = ( volt / cur )
	#print ("Rcalc = %4.4f GOhm, I = %1.5f nA, V = %4.4f V" % (rval/1E9, cur * 1e9, volt) )
	print (time.strftime("%d/%m/%Y-%H:%M:%S;") + ("\033[1;32m%1.6f nA \033[1;34m%4.4f V \033[1;35m%8.5f Gohm, \033[1;36m%3.2f C, %3.2f %% %4.2f hPa\033[1;39m" % (cur * 1e9, volt, rval/1E9, float(exttemp),float(rh),float(hectopascals) ) ) )
	o1.write (time.strftime("%d/%m/%Y-%H:%M:%S;") + ("%1.6f;%4.4f;%e;%3.2f;%3.2f;%4.2f;\r\n" % (cur * 1e9, volt, rval, float(exttemp),float(rh),float(hectopascals) ) ) )

	get_THP() # Read Temp, RH, Press from sensor
        time.sleep(slp)
	
	inst.write("LOP?\n")
	str = inst.read(140)
	#print str

o1.close()
quit()

'''
	inst.write("DI 1,14,1000E-9,10,0\n") #Output 10V, 12 - 10V range, 10uA current 
	inst.write("PA 2\n")
	inst.write("XE\n")
        time.sleep(slp)
	inst.write("XE\n")
        time.sleep(slp)
        str = inst.read()
#        print str

	rvals = str.split("\r\n")
        rvalsv = rvals[0].split("CAV")
	try:
	    rvalsv = rvals[0].split("CAV")            
	    volt = float(rvalsv[1])
	except:
	    rvalsv = rvals[0].split("NAV")            
	    volt = float(rvalsv[1])
	volt = float(rvalsv[1])

        time.sleep(slp)
'''
